import { Nil } from '../interfaces';
/**
 * Gets the element at index `n` of `array`. If `n` is negative, the nth element from the end is returned.
 *
 * Differences from lodash:
 * - does not handle a fractional value for `index`
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 1,923 bytes
 * - Micro-dash: 94 bytes
 */
export declare function nth<T>(array: readonly T[], index: number): T;
export declare function nth<T>(array: Nil | readonly T[], index: number): T | undefined;
