import { ArrayIteratee, ArrayNarrowingIteratee, Cast, IfCouldBe, KeyNarrowingIteratee, Nil, ObjectIteratee, ValueNarrowingIteratee } from '../interfaces';
/**
 * Iterates over elements of `collection`, returning an array of all elements `predicate` returns truthy for.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 16,224 bytes
 * - Micro-dash: 319 bytes
 */
export declare function filter<I, O>(array: Nil | readonly I[], predicate: ArrayNarrowingIteratee<O>): Array<Extract<I, O> | Extract<O, I>>;
export declare function filter<T>(array: Nil | readonly T[], predicate: ArrayIteratee<T, boolean>): T[];
export declare function filter<I, O>(object: I | Nil, predicate: ValueNarrowingIteratee<I, O>): Array<Extract<I[keyof I], O> | Extract<O, I[keyof I]>>;
export declare function filter<I, O>(object: I | Nil, predicate: KeyNarrowingIteratee<I, O>): Array<{
    [K in keyof I]: IfCouldBe<Cast<K, string>, O, I[K]>;
}[keyof I]>;
export declare function filter<T>(object: Nil | T, predicate: ObjectIteratee<T, boolean>): Array<T[keyof T]>;
