import { ArrayIteratee, Nil, ObjectIteratee } from '../interfaces';
/**
 * Creates a flattened array of values by running each element in `collection` thru `iteratee` and flattening the mapped results.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 16,579 bytes
 * - Micro-dash: 481 bytes
 */
export declare function flatMap<I, O>(array: Nil | readonly I[], iteratee: ArrayIteratee<I, O | O[]>): O[];
export declare function flatMap<T, O>(object: Nil | T, iteratee: ObjectIteratee<T, O | O[]>): O[];
