import { ArrayIteratee, ObjectIteratee } from '../interfaces';
/**
 * This function is like `forEach` except that it iterates over elements of `collection` from right to left.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 4,524 bytes
 * - Micro-dash: 245 bytes
 */
export declare function forEachRight<T>(array: readonly T[] | undefined, iteratee: ArrayIteratee<T, boolean | void>): T[];
export declare function forEachRight<T>(object: T | undefined, iteratee: ObjectIteratee<T, boolean | void>): T;
export declare function forEachRightOfArray<T>(array: readonly T[], iteratee: ArrayIteratee<T, boolean | void>): void;
