import { ArrayIteratee, ArrayNarrowingIteratee, Cast, KeyNarrowingIteratee, Nil, ObjectIteratee, ValueNarrowingIteratee } from '../interfaces';
/**
 * The opposite of `filter`; this function returns the elements of `collection` that `predicate` does **not** return truthy for.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 16,556 bytes
 * - Micro-dash: 375 bytes
 */
export declare function reject<I, O>(array: Nil | readonly I[], predicate: ArrayNarrowingIteratee<O>): Array<Exclude<I, O>>;
export declare function reject<T>(array: Nil | readonly T[], predicate: ArrayIteratee<T, boolean>): T[];
export declare function reject<I, O>(object: I | Nil, predicate: ValueNarrowingIteratee<I, O>): Array<Exclude<I[keyof I], O>>;
export declare function reject<I, O>(object: I | Nil, predicate: KeyNarrowingIteratee<I, O>): Array<{
    [K in keyof I]: Cast<K, string> extends O ? never : I[K];
}[keyof I]>;
export declare function reject<T>(object: Nil | T, predicate: ObjectIteratee<T, boolean>): Array<T[keyof T]>;
