import { Nil } from '../interfaces';
/**
 * Gets `n` random elements at unique keys from `collection` up to the size of `collection`.
 *
 * Differences from lodash:
 * - no special treatment given to fraction values of `n`
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 5,786 bytes
 * - Micro-dash: 826 bytes
 */
export declare function sampleSize<T>(array: Nil | readonly T[], n?: number): T[];
export declare function sampleSize<T>(object: Nil | T, n?: number): Array<T[keyof T]>;
