/**
 * Produces a random number between the inclusive `lower` and `upper` bounds. If only one argument is provided a number between `0` and the given number is returned. If `floating` is true, or either `lower` or `upper` are floats, a floating-point number is returned instead of an integer.
 *
 * Differences from lodash:
 * - does not coerce arguments into finite numbers. E.g. if you supply `NaN` or `Infinity`, results are not guaranteed.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 2,740 bytes
 * - Micro-dash: 380 bytes
 */
export declare function random(floating?: boolean): number;
export declare function random(upper: number, floating?: boolean): number;
export declare function random(lower: number, upper: number, floating?: boolean): number;
export declare const randomInt: (lower: number, upper: number, floating: boolean) => number;
