import { ObjectIteratee } from '../interfaces';
/**
 * This function is like `forOwn` except that it iterates over properties of `object` in the opposite order.
 *
 * Differences from lodash:
 * - does not treat sparse arrays as dense
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 4,214 bytes
 * - Micro-dash: 261 bytes
 */
export declare function forOwnRight<T>(object: T, iteratee: ObjectIteratee<T, boolean | void>): T;
export declare function forOwnRightOfNonArray<T>(object: T, iteratee: ObjectIteratee<T, boolean | void>): T;
