/**
 * This function is like `set()` except that it accepts `updater` to produce the value to set.
 *
 * **Note:** This function mutates `object`.
 *
 * Differences from lodash:
 * - only accepts an array for `path`, not a dot-separated string
 * - does not handle `customizer` returning `undefined`
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 7,006 bytes
 * - Micro-dash: 191 bytes
 */
export declare function update<T>(object: T, path: ReadonlyArray<number | string>, updater: (val: any) => any): T;
